AbstractMarshallerImpl (Java Platform SE 8 )
Keywords: javax.xml.bind.helpers.AbstractMarshallerImpl class
Date: 2015-11-19

javax.xml.bind.helpers

## Class AbstractMarshallerImpl

- java.lang.Object
- - javax.xml.bind.helpers.AbstractMarshallerImpl

- All Implemented Interfaces:
    Marshaller

      public abstract class AbstractMarshallerImpl
      extends Object
      implements Marshaller

  Partial default `Marshaller` implementation.

  This class provides a partial default implementation for the `Marshaller` interface.

  The only methods that a JAXB Provider has to implement are `marshal(Object, javax.xml.transform.Result)`, `marshal(Object, javax.xml.stream.XMLStreamWriter)`, and `marshal(Object, javax.xml.stream.XMLEventWriter)`.

  Since:
    JAXB1.0
  See Also:
    `Marshaller`

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface javax.xml.bind.Marshaller

      `Marshaller.Listener`

  - ### Field Summary

    - ### Fields inherited from interface javax.xml.bind.Marshaller

      `JAXB_ENCODING, JAXB_FORMATTED_OUTPUT, JAXB_FRAGMENT, JAXB_NO_NAMESPACE_SCHEMA_LOCATION, JAXB_SCHEMA_LOCATION`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `AbstractMarshallerImpl()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `<A extends XmlAdapter> A` | `getAdapter(Class<A> type)` Gets the adapter associated with the specified type.
    `AttachmentMarshaller` | `getAttachmentMarshaller()`
    `protected String` | `getEncoding()` Convenience method for getting the current output encoding.
    `ValidationEventHandler` | `getEventHandler()` Return the current event handler or the default event handler if one hasn't been set.
    `protected String` | `getJavaEncoding(String encoding)` Gets the corresponding Java encoding name from an IANA name.
    `Marshaller.Listener` | `getListener()` Return `Marshaller.Listener` registered with this `Marshaller`.
    `Node` | `getNode(Object obj)` By default, the getNode method is unsupported and throw an `UnsupportedOperationException`.
    `protected String` | `getNoNSSchemaLocation()` Convenience method for getting the current noNamespaceSchemaLocation.
    `Object` | `getProperty(String name)` Default implementation of the getProperty method handles the four defined properties in Marshaller.
    `Schema` | `getSchema()` Get the JAXP 1.3 `Schema` object being used to perform marshal-time validation.
    `protected String` | `getSchemaLocation()` Convenience method for getting the current schemaLocation.
    `protected boolean` | `isFormattedOutput()` Convenience method for getting the formatted output flag.
    `protected boolean` | `isFragment()` Convenience method for getting the fragment flag.
    `void` | `marshal(Object obj, ContentHandler handler)` Marshal the content tree rooted at `jaxbElement` into SAX2 events.
    `void` | `marshal(Object jaxbElement, File output)` Marshal the content tree rooted at `jaxbElement` into a file.
    `void` | `marshal(Object obj, Node node)` Marshal the content tree rooted at `jaxbElement` into a DOM tree.
    `void` | `marshal(Object obj, OutputStream os)` Marshal the content tree rooted at `jaxbElement` into an output stream.
    `void` | `marshal(Object obj, Writer w)` Marshal the content tree rooted at `jaxbElement` into a Writer.
    `void` | `marshal(Object obj, XMLEventWriter writer)` Marshal the content tree rooted at `jaxbElement` into a `XMLEventWriter`.
    `void` | `marshal(Object obj, XMLStreamWriter writer)` Marshal the content tree rooted at `jaxbElement` into a `XMLStreamWriter`.
    `<A extends XmlAdapter> void` | `setAdapter(Class<A> type, A adapter)` Associates a configured instance of `XmlAdapter` with this marshaller.
    `void` | `setAdapter(XmlAdapter adapter)` Associates a configured instance of `XmlAdapter` with this marshaller.
    `void` | `setAttachmentMarshaller(AttachmentMarshaller am)` Associate a context that enables binary data within an XML document to be transmitted as XML-binary optimized attachment.
    `protected void` | `setEncoding(String encoding)` Convenience method for setting the output encoding.
    `void` | `setEventHandler(ValidationEventHandler handler)` Allow an application to register a validation event handler.
    `protected void` | `setFormattedOutput(boolean v)` Convenience method for setting the formatted output flag.
    `protected void` | `setFragment(boolean v)` Convenience method for setting the fragment flag.
    `void` | `setListener(Marshaller.Listener listener)` Register marshal event callback `Marshaller.Listener` with this `Marshaller`.
    `protected void` | `setNoNSSchemaLocation(String location)` Convenience method for setting the noNamespaceSchemaLocation.
    `void` | `setProperty(String name, Object value)` Default implementation of the setProperty method handles the four defined properties in Marshaller.
    `void` | `setSchema(Schema schema)` Specify the JAXP 1.3 `Schema` object that should be used to validate subsequent marshal operations against.
    `protected void` | `setSchemaLocation(String location)` Convenience method for setting the schemaLocation.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface javax.xml.bind.Marshaller

      `marshal`

- - ### Constructor Detail

    - #### AbstractMarshallerImpl

          public AbstractMarshallerImpl()

  - ### Method Detail

    - #### marshal

          public final void marshal(Object obj,
                                    OutputStream os)
                             throws JAXBException

      Description copied from interface: `Marshaller`
      Marshal the content tree rooted at `jaxbElement` into an output stream.
      Specified by:
        `marshal` in interface `Marshaller`
      Parameters:
        `obj` - The root of content tree to be marshalled.
        `os` - XML will be added to this stream.
      Throws:
        `JAXBException` - If any unexpected problem occurs during the marshalling.
        `MarshalException` - If the `ValidationEventHandler` returns false from its `handleEvent` method or the `Marshaller` is unable to marshal `obj` (or any object reachable from `obj`). See Marshalling a JAXB element.

    - #### marshal

          public void marshal(Object jaxbElement,
                              File output)
                       throws JAXBException

      Description copied from interface: `Marshaller`
      Marshal the content tree rooted at `jaxbElement` into a file.
      Specified by:
        `marshal` in interface `Marshaller`
      Parameters:
        `jaxbElement` - The root of content tree to be marshalled.
        `output` - File to be written. If this file already exists, it will be overwritten.
      Throws:
        `JAXBException` - If any unexpected problem occurs during the marshalling.
        `MarshalException` - If the `ValidationEventHandler` returns false from its `handleEvent` method or the `Marshaller` is unable to marshal `obj` (or any object reachable from `obj`). See Marshalling a JAXB element.

    - #### marshal

          public final void marshal(Object obj,
                                    Writer w)
                             throws JAXBException

      Description copied from interface: `Marshaller`
      Marshal the content tree rooted at `jaxbElement` into a Writer.
      Specified by:
        `marshal` in interface `Marshaller`
      Parameters:
        `obj` - The root of content tree to be marshalled.
        `w` - XML will be sent to this writer.
      Throws:
        `JAXBException` - If any unexpected problem occurs during the marshalling.
        `MarshalException` - If the `ValidationEventHandler` returns false from its `handleEvent` method or the `Marshaller` is unable to marshal `obj` (or any object reachable from `obj`). See Marshalling a JAXB element.

    - #### marshal

          public final void marshal(Object obj,
                                    ContentHandler handler)
                             throws JAXBException

      Description copied from interface: `Marshaller`
      Marshal the content tree rooted at `jaxbElement` into SAX2 events.
      Specified by:
        `marshal` in interface `Marshaller`
      Parameters:
        `obj` - The root of content tree to be marshalled.
        `handler` - XML will be sent to this handler as SAX2 events.
      Throws:
        `JAXBException` - If any unexpected problem occurs during the marshalling.
        `MarshalException` - If the `ValidationEventHandler` returns false from its `handleEvent` method or the `Marshaller` is unable to marshal `obj` (or any object reachable from `obj`). See Marshalling a JAXB element.

    - #### marshal

          public final void marshal(Object obj,
                                    Node node)
                             throws JAXBException

      Description copied from interface: `Marshaller`
      Marshal the content tree rooted at `jaxbElement` into a DOM tree.
      Specified by:
        `marshal` in interface `Marshaller`
      Parameters:
        `obj` - The content tree to be marshalled.
        `node` - DOM nodes will be added as children of this node. This parameter must be a Node that accepts children (`Document`, `DocumentFragment`, or `Element`)
      Throws:
        `JAXBException` - If any unexpected problem occurs during the marshalling.
        `MarshalException` - If the `ValidationEventHandler` returns false from its `handleEvent` method or the `Marshaller` is unable to marshal `jaxbElement` (or any object reachable from `jaxbElement`). See Marshalling a JAXB element.

    - #### getNode

          public Node getNode(Object obj)
                       throws JAXBException

      By default, the getNode method is unsupported and throw an `UnsupportedOperationException`. Implementations that choose to support this method must override this method.
      Specified by:
        `getNode` in interface `Marshaller`
      Parameters:
        `obj` - - JAXB Java representation of XML content
      Returns:
        the DOM tree view of the contentTree
      Throws:
        `JAXBException` - If any unexpected problem occurs

    - #### getEncoding

          protected String getEncoding()

      Convenience method for getting the current output encoding.
      Returns:
        the current encoding or "UTF-8" if it hasn't been set.

    - #### setEncoding

          protected void setEncoding(String encoding)

      Convenience method for setting the output encoding.
      Parameters:
        `encoding` - a valid encoding as specified in the Marshaller class documentation

    - #### getSchemaLocation

          protected String getSchemaLocation()

      Convenience method for getting the current schemaLocation.
      Returns:
        the current schemaLocation or null if it hasn't been set

    - #### setSchemaLocation

          protected void setSchemaLocation(String location)

      Convenience method for setting the schemaLocation.
      Parameters:
        `location` - the schemaLocation value

    - #### getNoNSSchemaLocation

          protected String getNoNSSchemaLocation()

      Convenience method for getting the current noNamespaceSchemaLocation.
      Returns:
        the current noNamespaceSchemaLocation or null if it hasn't been set

    - #### setNoNSSchemaLocation

          protected void setNoNSSchemaLocation(String location)

      Convenience method for setting the noNamespaceSchemaLocation.
      Parameters:
        `location` - the noNamespaceSchemaLocation value

    - #### isFormattedOutput

          protected boolean isFormattedOutput()

      Convenience method for getting the formatted output flag.
      Returns:
        the current value of the formatted output flag or false if it hasn't been set.

    - #### setFormattedOutput

          protected void setFormattedOutput(boolean v)

      Convenience method for setting the formatted output flag.
      Parameters:
        `v` - value of the formatted output flag.

    - #### isFragment

          protected boolean isFragment()

      Convenience method for getting the fragment flag.
      Returns:
        the current value of the fragment flag or false if it hasn't been set.

    - #### setFragment

          protected void setFragment(boolean v)

      Convenience method for setting the fragment flag.
      Parameters:
        `v` - value of the fragment flag.

    - #### getJavaEncoding

          protected String getJavaEncoding(String encoding)
                                    throws UnsupportedEncodingException

      Gets the corresponding Java encoding name from an IANA name. This method is a helper method for the derived class to convert encoding names.
      Throws:
        `UnsupportedEncodingException` - If this implementation couldn't find the Java encoding name.

    - #### setProperty

          public void setProperty(String name,
                                  Object value)
                           throws PropertyException

      Default implementation of the setProperty method handles the four defined properties in Marshaller. If a provider needs to handle additional properties, it should override this method in a derived class.
      Specified by:
        `setProperty` in interface `Marshaller`
      Parameters:
        `name` - the name of the property to be set. This value can either be specified using one of the constant fields or a user supplied string.
        `value` - the value of the property to be set
      Throws:
        `PropertyException` - when there is an error processing the given property or value

    - #### getProperty

          public Object getProperty(String name)
                             throws PropertyException

      Default implementation of the getProperty method handles the four defined properties in Marshaller. If a provider needs to support additional provider specific properties, it should override this method in a derived class.
      Specified by:
        `getProperty` in interface `Marshaller`
      Parameters:
        `name` - the name of the property to retrieve
      Returns:
        the value of the requested property
      Throws:
        `PropertyException` - when there is an error retrieving the given property or value property name

    - #### getEventHandler

          public ValidationEventHandler getEventHandler()
                                                 throws JAXBException

      Description copied from interface: `Marshaller`
      Return the current event handler or the default event handler if one hasn't been set.
      Specified by:
        `getEventHandler` in interface `Marshaller`
      Returns:
        the current ValidationEventHandler or the default event handler if it hasn't been set
      Throws:
        `JAXBException` - if an error was encountered while getting the current event handler
      See Also:
        `Marshaller.getEventHandler()`

    - #### setEventHandler

          public void setEventHandler(ValidationEventHandler handler)
                               throws JAXBException

      Description copied from interface: `Marshaller`
      Allow an application to register a validation event handler.

      The validation event handler will be called by the JAXB Provider if any validation errors are encountered during calls to any of the marshal API's. If the client application does not register a validation event handler before invoking one of the marshal methods, then validation events will be handled by the default event handler which will terminate the marshal operation after the first error or fatal error is encountered.

      Calling this method with a null parameter will cause the Marshaller to revert back to the default default event handler.

      Specified by:
        `setEventHandler` in interface `Marshaller`
      Parameters:
        `handler` - the validation event handler
      Throws:
        `JAXBException` - if an error was encountered while setting the event handler
      See Also:
        `Marshaller.setEventHandler(ValidationEventHandler)`

    - #### marshal

          public void marshal(Object obj,
                              XMLEventWriter writer)
                       throws JAXBException

      Description copied from interface: `Marshaller`
      Marshal the content tree rooted at `jaxbElement` into a `XMLEventWriter`.
      Specified by:
        `marshal` in interface `Marshaller`
      Parameters:
        `obj` - The content tree rooted at jaxbElement to be marshalled.
        `writer` - XML will be sent to this writer.
      Throws:
        `JAXBException` - If any unexpected problem occurs during the marshalling.
        `MarshalException` - If the `ValidationEventHandler` returns false from its `handleEvent` method or the `Marshaller` is unable to marshal `obj` (or any object reachable from `obj`). See Marshalling a JAXB element.

    - #### marshal

          public void marshal(Object obj,
                              XMLStreamWriter writer)
                       throws JAXBException

      Description copied from interface: `Marshaller`
      Marshal the content tree rooted at `jaxbElement` into a `XMLStreamWriter`.
      Specified by:
        `marshal` in interface `Marshaller`
      Parameters:
        `obj` - The content tree to be marshalled.
        `writer` - XML will be sent to this writer.
      Throws:
        `JAXBException` - If any unexpected problem occurs during the marshalling.
        `MarshalException` - If the `ValidationEventHandler` returns false from its `handleEvent` method or the `Marshaller` is unable to marshal `obj` (or any object reachable from `obj`). See Marshalling a JAXB element.

    - #### setSchema

          public void setSchema(Schema schema)

      Description copied from interface: `Marshaller`
      Specify the JAXP 1.3 `Schema` object that should be used to validate subsequent marshal operations against. Passing null into this method will disable validation.

      This method allows the caller to validate the marshalled XML as it's marshalled.

      Initially this property is set to `null`.

      Specified by:
        `setSchema` in interface `Marshaller`
      Parameters:
        `schema` - Schema object to validate marshal operations against or null to disable validation

    - #### getSchema

          public Schema getSchema()

      Description copied from interface: `Marshaller`
      Get the JAXP 1.3 `Schema` object being used to perform marshal-time validation. If there is no Schema set on the marshaller, then this method will return null indicating that marshal-time validation will not be performed.
      Specified by:
        `getSchema` in interface `Marshaller`
      Returns:
        the Schema object being used to perform marshal-time validation or null if not present.

    - #### setAdapter

          public void setAdapter(XmlAdapter adapter)

      Description copied from interface: `Marshaller`
      Associates a configured instance of `XmlAdapter` with this marshaller.

      This is a convenience method that invokes `setAdapter(adapter.getClass(),adapter);`.

      Specified by:
        `setAdapter` in interface `Marshaller`
      See Also:
        `Marshaller.setAdapter(Class,XmlAdapter)`

    - #### setAdapter

          public <A extends XmlAdapter> void setAdapter(Class<A> type,
                                                        A adapter)

      Description copied from interface: `Marshaller`
      Associates a configured instance of `XmlAdapter` with this marshaller.

      Every marshaller internally maintains a `Map`<`Class`,`XmlAdapter`>, which it uses for marshalling classes whose fields/methods are annotated with `XmlJavaTypeAdapter`.

      This method allows applications to use a configured instance of `XmlAdapter`. When an instance of an adapter is not given, a marshaller will create one by invoking its default constructor.

      Specified by:
        `setAdapter` in interface `Marshaller`
      Parameters:
        `type` - The type of the adapter. The specified instance will be used when `XmlJavaTypeAdapter.value()` refers to this type.
        `adapter` - The instance of the adapter to be used. If null, it will un-register the current adapter set for this type.

    - #### getAdapter

          public <A extends XmlAdapter> A getAdapter(Class<A> type)

      Description copied from interface: `Marshaller`
      Gets the adapter associated with the specified type. This is the reverse operation of the `Marshaller.setAdapter(javax.xml.bind.annotation.adapters.XmlAdapter)` method.
      Specified by:
        `getAdapter` in interface `Marshaller`

    - #### setAttachmentMarshaller

          public void setAttachmentMarshaller(AttachmentMarshaller am)

      Description copied from interface: `Marshaller`

      Associate a context that enables binary data within an XML document to be transmitted as XML-binary optimized attachment. The attachment is referenced from the XML document content model by content-id URIs(cid) references stored within the xml document.

      Specified by:
        `setAttachmentMarshaller` in interface `Marshaller`

    - #### getAttachmentMarshaller

          public AttachmentMarshaller getAttachmentMarshaller()

      Specified by:
        `getAttachmentMarshaller` in interface `Marshaller`

    - #### setListener

          public void setListener(Marshaller.Listener listener)

      Description copied from interface: `Marshaller`

      Register marshal event callback `Marshaller.Listener` with this `Marshaller`.

      There is only one Listener per Marshaller. Setting a Listener replaces the previous set Listener. One can unregister current Listener by setting listener to `null`.

      Specified by:
        `setListener` in interface `Marshaller`
      Parameters:
        `listener` - an instance of a class that implements `Marshaller.Listener`

    - #### getListener

          public Marshaller.Listener getListener()

      Description copied from interface: `Marshaller`

      Return `Marshaller.Listener` registered with this `Marshaller`.

      Specified by:
        `getListener` in interface `Marshaller`
      Returns:
        registered `Marshaller.Listener` or `null` if no Listener is registered with this Marshaller.

Submit a bug or feature
For further API reference and developer documentation, see Java SE Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.
Copyright © 1993, 2015, Oracle and/or its affiliates. All rights reserved.